Overview | Package | Class | Tree | Deprecated | Index | Help
| Compoze Software, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.compoze.exchange
Class Messages

    java.lang.Object
      com.compoze.exchange.Messages

All Implemented Interfaces:
  java.io.Serializable

public class Messages
extends java.lang.Object
implements java.io.Serializable

This class contains the methods used for message manipulation.

See Also:
  Serialized Form

Field Summary
`protected Session` | `m_session`

Method Summary
`DistributionList[]` | `createDistLists(Message[] messages)` Creates an array of distribution lists from the messages.
`int` | `serverAddAttachment(java.lang.String sMessageID, AttachmentType attachmentType, java.lang.String sName, java.lang.String sSource, int iPosition, javax.activation.DataHandler handler)` Hits the server to add an attachment to a message.
`int` | `serverAddAttachment(java.lang.String sMessageID, java.lang.String sFolderID, AttachmentType attachmentType, java.lang.String sName, java.lang.String sSource, int iPosition, javax.activation.DataHandler handler)` Hits the server to add an attachment to a message.
`protected void` | `serverCancelMeeting(java.lang.String sMessageID, PropertyValue[] values, boolean bSeries, boolean bSend, boolean bSaveInSent, boolean bDelete)` Hits the server to delete a send a meeting cancellation and optionally delete the meeting.
`void` | `serverCopyMessages(java.lang.String[] srcMessageIDs, java.lang.String sTargetFolderID)` Hits the server to copy the specified messages to another folder.
`void` | `serverCopyMessages(java.lang.String[] srcMessageIDs, java.lang.String sFolderID, java.lang.String sTargetFolderID)` Hits the server to copy the specified messages to another folder.
`Appointment` | `serverCreateAppointment(DefaultFolderType type, PropertyValue[] values, Recipient[] recipients, RecurrencePattern pattern)` Hits the server to create an appointment.
`Appointment` | `serverCreateAppointment(DefaultFolderType type, PropertyValue[] values, Recipient[] recipients, RecurrencePattern pattern, boolean bSend, boolean bSaveSent)` Hits the server to create an appointment.
`Appointment` | `serverCreateAppointment(java.lang.String sFolderID, PropertyValue[] values, Recipient[] recipients, RecurrencePattern pattern)` Hits the server to create an appointment.
`Appointment` | `serverCreateAppointment(java.lang.String sFolderID, PropertyValue[] values, Recipient[] recipients, RecurrencePattern pattern, boolean bSend, boolean bSaveSent)` Hits the server to create an appointment.
`Contact` | `serverCreateContact(DefaultFolderType type, PropertyValue[] values)` Hits the server to create a contact.
`Contact` | `serverCreateContact(java.lang.String sFolderID, PropertyValue[] values)` Hits the server to create a contact.
`Journal` | `serverCreateJournal(DefaultFolderType type, PropertyValue[] values)` Hits the server to create a journal entry.
`Journal` | `serverCreateJournal(java.lang.String sFolderID, PropertyValue[] values)` Hits the server to create a journal entry.
`java.lang.String` | `serverCreateMessage(DefaultFolderType folderType, PropertyValue[] values)` Hits the server to create a message.
`java.lang.String` | `serverCreateMessage(DefaultFolderType folderType, PropertyValue[] values, Recipient[] recipients)` Hits the server to create a message.
`java.lang.String` | `serverCreateMessage(java.lang.String sFolderID, PropertyValue[] values)` Hits the server to create a message.
`java.lang.String` | `serverCreateMessage(java.lang.String sFolderID, PropertyValue[] values, Recipient[] recipients)` Hits the server to create a message.
`Task` | `serverCreateTask(DefaultFolderType type, PropertyValue[] values)` Hits the server to create a task.
`Task` | `serverCreateTask(java.lang.String sFolderID, PropertyValue[] values)` Hits the server to create a task.
`Message` | `serverCreateTaskRequest(DefaultFolderType type, java.lang.String sTaskID, PropertyValue[] values, Recipient[] recipients, boolean bSend, boolean bSaveInSent)` Hits the server to create a task.
`Message` | `serverCreateTaskRequest(java.lang.String sFolderID, java.lang.String sTaskID, PropertyValue[] values, Recipient[] recipients, boolean bSend, boolean bSaveInSent)` Hits the server to create a task request.
`void` | `serverDeleteAttachment(java.lang.String sMessageID, int iIndex)` Hits the server to delete an attachment from a message.
`void` | `serverDeleteAttachment(java.lang.String sMessageID, java.lang.String sFolderID, int iIndex)` Hits the server to delete an attachment from a message.
`void` | `serverDeleteMessages(java.lang.String[] messageIDs, boolean bDeletedItems)` Hits the server to delete the specified messages.
`void` | `serverDeleteMessages(java.lang.String[] messageIDs, boolean bDeletedItems, boolean bDeleteSeries)` Hits the server to delete the specified messages.
`void` | `serverDeleteMessages(java.lang.String[] messageIDs, java.lang.String sFolderID, boolean bDeletedItems)` Hits the server to delete the specified messages.
`void` | `serverDeleteMessages(java.lang.String[] messageIDs, java.lang.String sFolderID, boolean bDeletedItems, boolean bDeleteSeries)` Hits the server to delete the specified messages.
`Message` | `serverForwardMessage(java.lang.String sMessageID, PropertyValue[] values, PropertyKey[] keys)` Hits the server to create a new message in the oubox suitable for forwarding a specified message.
`Message` | `serverForwardMessage(java.lang.String sMessageID, PropertyValue[] values, PropertyKey[] keys, boolean bCopyRichText)` Hits the server to create a new message in the oubox suitable for forwarding a specified message.
`Message` | `serverForwardMessage(java.lang.String sMessageID, java.lang.String sFolderID, PropertyValue[] values, PropertyKey[] keys)` Hits the server to create a new message in the oubox suitable for forwarding a specified message.
`Message` | `serverForwardMessage(java.lang.String sMessageID, java.lang.String sFolderID, PropertyValue[] values, PropertyKey[] keys, boolean bCopyRichText)` Hits the server to create a new message in the oubox suitable for forwarding a specified message.
`Message` | `serverForwardMessage(java.lang.String sMessageID, java.lang.String sFolderID, PropertyValue[] values, PropertyKey[] keys, boolean bCopyRichText, boolean bSeries)` Hits the server to create a new message in the oubox suitable for forwarding a specified message.
`Appointment[]` | `serverGetAppointments(java.util.Date startTime, java.util.Date endTime, PropertyKey[] apptProps)` Queries the server to get appointments from the default calendar folder..
`Appointment[]` | `serverGetAppointments(DefaultFolderType folderType, java.util.Date startTime, java.util.Date endTime, PropertyKey[] apptProps)` Queries the server to get appointments.
`Appointment[]` | `serverGetAppointments(java.lang.String[] apptIDs, java.util.Date instanceDate, PropertyKey[] apptProps)` Queries the server to get appointments.
`Appointment[]` | `serverGetAppointments(java.lang.String[] apptIDs, PropertyKey[] apptProps)` Queries the server to get appointments.
`javax.activation.DataHandler` | `serverGetAttachment(java.lang.String sMessageID, int iIndex)` Hits the server to get an attachment from a message.
`javax.activation.DataHandler` | `serverGetAttachment(java.lang.String sMessageID, java.lang.String sFolderID, int iIndex)` Hits the server to get an attachment from a message.
`javax.activation.DataHandler` | `serverGetAttachment(java.lang.String sMessageID, java.lang.String sFolderID, int iEmbeddedIndex, int iAttachmentIndex)` Hits the server to get an attachment from a message.
`Attachment[]` | `serverGetAttachments(java.lang.String sMessageID, PropertyKey[] keys)` Hits the server to get detailed information about an attachment.
`Attachment[]` | `serverGetAttachments(java.lang.String sMessageID, java.lang.String sFolderID, PropertyKey[] keys)` Hits the server to get detailed information about an attachment.
`Contact` | `serverGetContact(java.lang.String sContactID, PropertyKey[] keys)` Queries the server to get a single contact.
`Contact[]` | `serverGetContacts(DefaultFolderType type, int iStartIndex, int iEndIndex, int iDepth, PropertyKey[] keys, SortProperty[] sortProps, PropertyValue[] filterProps, boolean bOr, boolean bNot, boolean bHidden)` Queries the server to get contacts.
`Contact[]` | `serverGetContacts(java.lang.String[] contactIDs, PropertyKey[] keys)` Queries the server to get contacts by their IDs.
`Contact[]` | `serverGetContacts(java.lang.String sFolderID, int iStartIndex, int iEndIndex, int iDepth, PropertyKey[] keys, SortProperty[] sortProps, PropertyValue[] filterProps, boolean bOr, boolean bNot, boolean bHidden)` Queries the server to get contacts.
`DistributionList` | `serverGetDistributionList(java.lang.String sDistListID, PropertyKey[] keys)` Queries the server to get a single distribution list.
`DistributionList[]` | `serverGetDistributionLists(DefaultFolderType type, int iStartIndex, int iEndIndex, int iDepth, PropertyKey[] keys, SortProperty[] sortProps, PropertyValue[] filterProps, boolean bOr, boolean bNot, boolean bHidden)` Queries the server to get distribution lists
`DistributionList[]` | `serverGetDistributionLists(java.lang.String[] distListIDs, PropertyKey[] keys)` Queries the server to get distribution lists by their IDs.
`DistributionList[]` | `serverGetDistributionLists(java.lang.String sFolderID, int iStartIndex, int iEndIndex, int iDepth, PropertyKey[] keys, SortProperty[] sortProps, PropertyValue[] filterProps, boolean bOr, boolean bNot, boolean bHidden)` Queries the server to get distribution lists.
`Message` | `serverGetEmbeddedMessage(java.lang.String sMessageID, java.lang.String sFolderID, PropertyKey[] messageKeys, int iIndex)` Queries the server to get an embedded message (an attachment that is a message).
`Message` | `serverGetMessage(java.lang.String sMessageID, PropertyKey[] keys)` Queries the server to get a single message.
`Message` | `serverGetMessage(java.lang.String sMessageID, java.lang.String sFolderID, PropertyKey[] keys)` Queries the server to get a single message.
`int` | `serverGetMessageCount(DefaultFolderType type, int iDepth, PropertyValue[] filterProps, boolean bOr, boolean bNot, boolean bHidden)` Queries the server to get a count of messages.
`int` | `serverGetMessageCount(java.lang.String sFolderID, int iDepth, PropertyValue[] filterProps, boolean bOr, boolean bNot, boolean bHidden)` Queries the server to get a count of messages.
`Message[]` | `serverGetMessages(DefaultFolderType folderType, int iStartIndex, int iEndIndex, int iDepth, PropertyKey[] messageKeys, SortProperty[] sortProps, PropertyValue[] filterProps, boolean bOr, boolean bNot, boolean bHidden)` Queries the server to get messages.
`Message[]` | `serverGetMessages(java.lang.String[] messageIDs, PropertyKey[] keys)` Queries the server to get messages by their IDs.
`Message[]` | `serverGetMessages(java.lang.String[] messageIDs, java.lang.String sFolderID, PropertyKey[] keys)` Queries the server to get messages by their IDs.
`Message[]` | `serverGetMessages(java.lang.String sFolderID, int iStartIndex, int iEndIndex, int iDepth, PropertyKey[] messageKeys, SortProperty[] sortProps, PropertyValue[] filterProps, boolean bOr, boolean bNot, boolean bHidden)` Queries the server to get messages.
`Task` | `serverGetTask(java.lang.String sTaskID, PropertyKey[] keys)` Queries the server to get a single task.
`Task[]` | `serverGetTasks(java.lang.String[] taskIDs, PropertyKey[] keys)` Queries the server to get tasks by their IDs.
`Task[]` | `serverGetTasks(java.lang.String sFolderID, int iStartIndex, int iEndIndex, int iDepth, PropertyKey[] keys, SortProperty[] sortProps, PropertyValue[] filterProps, boolean bOr, boolean bNot, boolean bHidden)` Queries the server to get tasks.
`void` | `serverMoveMessages(java.lang.String[] srcMessageIDs, DefaultFolderType folderType)` Hits the server to move the specified messages to another folder.
`void` | `serverMoveMessages(java.lang.String[] srcMessageIDs, java.lang.String sTargetFolderID)` Hits the server to move the specified messages to another folder.
`void` | `serverMoveMessages(java.lang.String[] srcMessageIDs, java.lang.String sFolderID, DefaultFolderType folderType)` Hits the server to move the specified messages to another folder.
`void` | `serverMoveMessages(java.lang.String[] srcMessageIDs, java.lang.String sFolderID, java.lang.String sTargetFolderID)` Hits the server to move the specified messages to another folder.
`Message` | `serverReplyToMessage(java.lang.String sMessageID, PropertyValue[] values, PropertyKey[] keys, boolean bReplyAll)` Hits the server to create a new message in the outbox suitable for replying to a specified message.
`Message` | `serverReplyToMessage(java.lang.String sMessageID, java.lang.String sFolderID, PropertyValue[] values, PropertyKey[] keys, boolean bReplyAll)` Hits the server to create a new message in the outbox suitable for replying to a specified message.
`UnresolvedRecipient[]` | `serverResolveRecipients(java.lang.String sMessageID, boolean bRemove)` Resolves recipients on a message.
`UnresolvedRecipient[]` | `serverResolveRecipients(java.lang.String sMessageID, boolean bRemove, boolean bSeries)` Resolves recipients on a message.
`void` | `serverRespondToMeetingRequest(java.lang.String sMessageID, PropertyValue[] values, ResponseStatus status)` Hits the server to reply immediately to a meeting request.
`void` | `serverRespondToMeetingRequest(java.lang.String sMessageID, java.lang.String sFolderID, PropertyValue[] values, ResponseStatus status)` Hits the server to reply immediately to a meeting request.
`void` | `serverRespondToTaskRequest(java.lang.String sMessageID, PropertyValue[] values, TaskResponseStatus status)` Hits the server to respond to to a task request.
`void` | `serverRespondToTaskRequest(java.lang.String sMessageID, java.lang.String sFolderID, PropertyValue[] values, TaskResponseStatus status, boolean bSaveSent)` Hits the server to respond to a task request.
`void` | `serverUpdateMessage(java.lang.String sMessageID, PropertyValue[] values)` Hits the server to update a message.
`void` | `serverUpdateMessages(java.lang.String[] messageIDs, PropertyValue[] values)` Hits the server to update the specified messages.
`void` | `serverUpdateMessages(java.lang.String[] messageIDs, PropertyValue[] values, Recipient[] recipients, boolean bSend, boolean bSaveInSent)` Hits the server to update the specified messages.
`void` | `serverUpdateMessages(java.lang.String[] messageIDs, PropertyValue[] values, Recipient[] recipients, RecurrencePattern pattern, ResponseStatus responseStatus, boolean bSeries, boolean bSend, boolean bSaveInSent)` Hits the server to update the specified messages.
`void` | `serverUpdateMessages(java.lang.String[] messageIDs, PropertyValue[] values, Recipient[] recipients, ResponseStatus responseStatus, boolean bSend, boolean bSaveInSent)` Hits the server to update the specified messages.
`void` | `serverUpdateMessages(java.lang.String[] messageIDs, PropertyValue[] values, Recipient[] recipients, ResponseStatus responseStatus, boolean bSeries, boolean bSend, boolean bSaveInSent)` Hits the server to update the specified messages.
`void` | `serverUpdateMessages(java.lang.String[] messageIDs, java.lang.String sFolderID, PropertyValue[] values, Recipient[] recipients, int[] deleteRecipients, RecurrencePattern pattern, ResponseStatus responseStatus, boolean bSeries, boolean bSend, boolean bSaveInSent)` Hits the server to update the specified messages.
`void` | `serverUpdateMessages(java.lang.String[] messageIDs, java.lang.String sFolderID, PropertyValue[] values, Recipient[] recipients, int[] deleteRecipients, RecurrencePattern pattern, ResponseStatus responseStatus, TaskResponseStatus taskResponseStatus, TaskStatus taskStatus, boolean bSeries, boolean bSend, boolean bSaveInSent)` Hits the server to update the specified messages.
`void` | `serverUpdateMessages(java.lang.String[] messageIDs, java.lang.String sFolderID, PropertyValue[] values, Recipient[] recipients, RecurrencePattern pattern, ResponseStatus responseStatus, boolean bSeries, boolean bSend, boolean bSaveInSent)` Hits the server to update the specified messages.
`void` | `serverUpdateMessages(java.lang.String[] messageIDs, java.lang.String sFolderID, PropertyValue[] values, Recipient[] recipients, RecurrencePattern pattern, ResponseStatus responseStatus, TaskResponseStatus taskResponseStatus, boolean bSeries, boolean bSend, boolean bSaveInSent)` Hits the server to update the specified messages.
`void` | `serverUpdateMessages(java.lang.String[] messageIDs, java.lang.String sFolderID, PropertyValue[] values, Recipient[] recipients, ResponseStatus responseStatus, boolean bSeries, boolean bSend, boolean bSaveInSent)` Hits the server to update the specified messages.
`boolean` | `serverUpdateTaskFromRequest(DefaultFolderType folderType, java.lang.String sTaskRequestID)` Updates a linked task from a task request.
`boolean` | `serverUpdateTaskFromRequest(java.lang.String sFolderID, java.lang.String sTaskRequestID)` Updates a linked task from a task request.
`void` | `serverUpdateTaskRequest(java.lang.String sMessageID, PropertyValue[] values, TaskStatus taskStatus, boolean bSaveInSent)` Hits the server to update the specified task and send an update to the originator of the task request that created it.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### m_session

    protected Session m_session

Method Detail

### serverGetContact

    public Contact serverGetContact(java.lang.String sContactID,
                                    PropertyKey[] keys)
                             throws ExchangeException

  Queries the server to get a single contact.

  Parameters:
    `sContactID` - the contact ID
    `keys` - the properties to fetch for each contact
  Returns:
    the contact or `null`if not found
  Throws:
    `ExchangeException`

### serverGetContacts

    public Contact[] serverGetContacts(java.lang.String[] contactIDs,
                                       PropertyKey[] keys)
                                throws ExchangeException

  Queries the server to get contacts by their IDs.

  Parameters:
    `contactIDs` - the contact IDs
    `keys` - the properties to fetch for each contact
  Returns:
    the array of contacts
  Throws:
    `ExchangeException`

### serverGetTask

    public Task serverGetTask(java.lang.String sTaskID,
                              PropertyKey[] keys)
                       throws ExchangeException

  Queries the server to get a single task.

  Parameters:
    `sTaskID` - the task ID
    `keys` - the properties to fetch for each task
  Returns:
    the task or `null`if not found
  Throws:
    `ExchangeException`

### serverGetTasks

    public Task[] serverGetTasks(java.lang.String[] taskIDs,
                                 PropertyKey[] keys)
                          throws ExchangeException

  Queries the server to get tasks by their IDs.

  Parameters:
    `taskIDs` - the task IDs
    `keys` - the properties to fetch for each task
  Returns:
    the array of tasks
  Throws:
    `ExchangeException`

### serverGetMessage

    public Message serverGetMessage(java.lang.String sMessageID,
                                    PropertyKey[] keys)
                             throws ExchangeException

  Queries the server to get a single message.

  Parameters:
    `sMessageID` - the message ID
    `keys` - the properties to fetch for each message
  Returns:
    the message or `null`if not found
  Throws:
    `ExchangeException`

### serverGetMessage

    public Message serverGetMessage(java.lang.String sMessageID,
                                    java.lang.String sFolderID,
                                    PropertyKey[] keys)
                             throws ExchangeException

  Queries the server to get a single message.

  Parameters:
    `sMessageID` - the message ID
    `sFolderID` - the folder ID (used as a backup in case retrieving message by its ID fails)
    `keys` - the properties to fetch for each message
  Returns:
    the message, or `null`if not found
  Throws:
    `ExchangeException`

### serverGetMessages

    public Message[] serverGetMessages(java.lang.String[] messageIDs,
                                       PropertyKey[] keys)
                                throws ExchangeException

  Queries the server to get messages by their IDs.

  Parameters:
    `messageIDs` - the message IDs
    `keys` - the properties to fetch for each message
  Returns:
    the array of messages
  Throws:
    `ExchangeException`

### serverGetMessages

    public Message[] serverGetMessages(java.lang.String[] messageIDs,
                                       java.lang.String sFolderID,
                                       PropertyKey[] keys)
                                throws ExchangeException

  Queries the server to get messages by their IDs.

  Parameters:
    `messageIDs` - the message IDs
    `sFolderID` - the folder ID (used as a backup in case retrieving message by its ID fails)
    `keys` - the properties to fetch for each message
  Returns:
    the array of messages
  Throws:
    `ExchangeException`

### serverGetMessages

    public Message[] serverGetMessages(java.lang.String sFolderID,
                                       int iStartIndex,
                                       int iEndIndex,
                                       int iDepth,
                                       PropertyKey[] messageKeys,
                                       SortProperty[] sortProps,
                                       PropertyValue[] filterProps,
                                       boolean bOr,
                                       boolean bNot,
                                       boolean bHidden)
                                throws ExchangeException

  Queries the server to get messages.

  Parameters:
    `sFolderID` - the folder ID
    `iStartIndex` - the start index endpoint (inclusive) or -1 for all
    `iEndIndex` - the end index highpoint (exclusive) or -1 for all
    `iDepth` - the depth of folders to use when calculating message count (0 for only starting folder, N for depth of N, -1 for infinite depth)
    `messageKeys` - the properties to fetch for each message
    `sortProps` - the properties to sort by
    `filterProps` - the properties to filter by
    `bOr` - if `true`, or the filter properties together
    `bNot` - if `true`, the condition is opposite
    `bHidden` - if `true`, get hidden messages rather than visible ones
  Throws:
    `ExchangeException`

### serverGetMessages

    public Message[] serverGetMessages(DefaultFolderType folderType,
                                       int iStartIndex,
                                       int iEndIndex,
                                       int iDepth,
                                       PropertyKey[] messageKeys,
                                       SortProperty[] sortProps,
                                       PropertyValue[] filterProps,
                                       boolean bOr,
                                       boolean bNot,
                                       boolean bHidden)
                                throws ExchangeException

  Queries the server to get messages.

  Parameters:
    `folderType` - the folder type
    `iStartIndex` - the start index endpoint (inclusive) or -1 for all
    `iEndIndex` - the end index highpoint (exclusive) or -1 for all
    `iDepth` - the depth of folders to use when calculating message count (0 for only starting folder, N for depth of N, -1 for infinite depth)
    `messageKeys` - the properties to fetch for each message
    `sortProps` - the properties to sort by
    `filterProps` - the properties to filter by
    `bOr` - if `true`, or the filter properties together
    `bNot` - if `true`, the condition is opposite
    `bHidden` - if `true`, get hidden messages rather than visible ones
  Throws:
    `ExchangeException`

### serverGetAppointments

    public Appointment[] serverGetAppointments(java.lang.String[] apptIDs,
                                               PropertyKey[] apptProps)
                                        throws ExchangeException

  Queries the server to get appointments.

  Parameters:
    `apptIDs` - the IDs of the appointments to retrieve
    `apptProps` - the properties of each appointment to retrieve
  Throws:
    `ExchangeException`

### serverGetAppointments

    public Appointment[] serverGetAppointments(java.lang.String[] apptIDs,
                                               java.util.Date instanceDate,
                                               PropertyKey[] apptProps)
                                        throws ExchangeException

  Queries the server to get appointments. The appointment IDs specified are the IDs of the series.

  Parameters:
    `instanceDate` - the date on which the instances occur
    `apptProps` - the properties of each appointment to retrieve
  Throws:
    `ExchangeException`

### serverGetAppointments

    public Appointment[] serverGetAppointments(java.util.Date startTime,
                                               java.util.Date endTime,
                                               PropertyKey[] apptProps)
                                        throws ExchangeException

  Queries the server to get appointments from the default calendar folder..

  Parameters:
    `startTime` - the starting time to get appointments
    `endTime` - the ending time to get appointments
    `apptProps` - the appointment properties to bring back
  Returns:
    the appointments
  Throws:
    `ExchangeException`

### serverGetAppointments

    public Appointment[] serverGetAppointments(DefaultFolderType folderType,
                                               java.util.Date startTime,
                                               java.util.Date endTime,
                                               PropertyKey[] apptProps)
                                        throws ExchangeException

  Queries the server to get appointments.

  Parameters:
    `folderType` - the folder type
    `startTime` - the starting time to get appointments, or `null` to go from the beginning of time
    `endTime` - the ending time to get appointments, or `null` to go until the end of time
    `apptProps` - the appointment properties to bring back
  Returns:
    the appointments
  Throws:
    `ExchangeException`

### serverGetContacts

    public Contact[] serverGetContacts(DefaultFolderType type,
                                       int iStartIndex,
                                       int iEndIndex,
                                       int iDepth,
                                       PropertyKey[] keys,
                                       SortProperty[] sortProps,
                                       PropertyValue[] filterProps,
                                       boolean bOr,
                                       boolean bNot,
                                       boolean bHidden)
                                throws ExchangeException

  Queries the server to get contacts.

  Parameters:
    `type` - the default folder type
    `iStartIndex` - the start index endpoint (inclusive) or -1 for all
    `iEndIndex` - the end index highpoint (exclusive) or -1 for all
    `iDepth` - the depth of folders to use when calculating message count (0 for only starting folder, N for depth of N, -1 for infinite depth)
    `keys` - the properties to fetch for each contact
    `sortProps` - the properties to sort by
    `filterProps` - the properties to filter by
    `bOr` - if `true`, or the filter properties together
    `bNot` - if `true`, the condition is opposite
    `bHidden` - if `true`, get hidden messages rather than visible ones
  Throws:
    `ExchangeException`

### serverGetContacts

    public Contact[] serverGetContacts(java.lang.String sFolderID,
                                       int iStartIndex,
                                       int iEndIndex,
                                       int iDepth,
                                       PropertyKey[] keys,
                                       SortProperty[] sortProps,
                                       PropertyValue[] filterProps,
                                       boolean bOr,
                                       boolean bNot,
                                       boolean bHidden)
                                throws ExchangeException

  Queries the server to get contacts.

  Parameters:
    `sFolderID` - the folder ID
    `iStartIndex` - the start index endpoint (inclusive) or -1 for all
    `iEndIndex` - the end index highpoint (exclusive) or -1 for all
    `iDepth` - the depth of folders to use when calculating message count (0 for only starting folder, N for depth of N, -1 for infinite depth)
    `keys` - the properties to fetch for each contact
    `sortProps` - the properties to sort by
    `filterProps` - the properties to filter by
    `bOr` - if `true`, or the filter properties together
    `bNot` - if `true`, the condition is opposite
    `bHidden` - if `true`, get hidden messages rather than visible ones
  Throws:
    `ExchangeException`

### serverGetDistributionList

    public DistributionList serverGetDistributionList(java.lang.String sDistListID,
                                                      PropertyKey[] keys)
                                               throws ExchangeException

  Queries the server to get a single distribution list.

  Parameters:
    `sDistListID` - the distribution list ID
    `keys` - the property keys to fetch for each dist list
  Returns:
    the distribution list of `null` if not found
  Throws:
    `ExchangeException`

### serverGetDistributionLists

    public DistributionList[] serverGetDistributionLists(java.lang.String[] distListIDs,
                                                         PropertyKey[] keys)
                                                  throws ExchangeException

  Queries the server to get distribution lists by their IDs.

  Parameters:
    `distListIDs` - the contact IDs
    `keys` - the properties to fetch for each contact
  Returns:
    the array of contacts
  Throws:
    `ExchangeException`

### serverGetDistributionLists

    public DistributionList[] serverGetDistributionLists(DefaultFolderType type,
                                                         int iStartIndex,
                                                         int iEndIndex,
                                                         int iDepth,
                                                         PropertyKey[] keys,
                                                         SortProperty[] sortProps,
                                                         PropertyValue[] filterProps,
                                                         boolean bOr,
                                                         boolean bNot,
                                                         boolean bHidden)
                                                  throws ExchangeException

  Queries the server to get distribution lists

  Parameters:
    `type` - the default folder type
    `iStartIndex` - the start index endpoint (inclusive) or -1 for all
    `iEndIndex` - the end index highpoint (exclusive) or -1 for all
    `iDepth` - the depth of folders to use when calculating message count (0 for only starting folder, N for depth of N, -1 for infinite depth)
    `keys` - the properties to fetch for each dist list
    `sortProps` - the properties to sort by
    `filterProps` - the properties to filter by
    `bOr` - if `true`, or the filter properties together
    `bNot` - if `true`, the condition is opposite
    `bHidden` - if `true`, get hidden messages rather than visible ones
  Throws:
    `ExchangeException`

### serverGetDistributionLists

    public DistributionList[] serverGetDistributionLists(java.lang.String sFolderID,
                                                         int iStartIndex,
                                                         int iEndIndex,
                                                         int iDepth,
                                                         PropertyKey[] keys,
                                                         SortProperty[] sortProps,
                                                         PropertyValue[] filterProps,
                                                         boolean bOr,
                                                         boolean bNot,
                                                         boolean bHidden)
                                                  throws ExchangeException

  Queries the server to get distribution lists.

  Parameters:
    `sFolderID` - the folder ID
    `iStartIndex` - the start index endpoint (inclusive) or -1 for all
    `iEndIndex` - the end index highpoint (exclusive) or -1 for all
    `iDepth` - the depth of folders to use when calculating message count (0 for only starting folder, N for depth of N, -1 for infinite depth)
    `keys` - the properties to fetch for each dist list
    `sortProps` - the properties to sort by
    `filterProps` - the properties to filter by
    `bOr` - if `true`, or the filter properties together
    `bNot` - if `true`, the condition is opposite
    `bHidden` - if `true`, get hidden messages rather than visible ones
  Throws:
    `ExchangeException`

### serverGetTasks

    public Task[] serverGetTasks(java.lang.String sFolderID,
                                 int iStartIndex,
                                 int iEndIndex,
                                 int iDepth,
                                 PropertyKey[] keys,
                                 SortProperty[] sortProps,
                                 PropertyValue[] filterProps,
                                 boolean bOr,
                                 boolean bNot,
                                 boolean bHidden)
                          throws ExchangeException

  Queries the server to get tasks.

  Parameters:
    `sFolderID` - the folder ID
    `iStartIndex` - the start index endpoint (inclusive) or -1 for all
    `iEndIndex` - the end index highpoint (exclusive) or -1 for all
    `iDepth` - the depth of folders to use when calculating message count (0 for only starting folder, N for depth of N, -1 for infinite depth)
    `keys` - the properties to fetch for each task
    `sortProps` - the properties to sort by
    `filterProps` - the properties to filter by
    `bOr` - if `true`, or the filter properties together
    `bNot` - if `true`, the condition is opposite
    `bHidden` - if `true`, get hidden messages rather than visible ones
  Throws:
    `ExchangeException`

### serverGetMessageCount

    public int serverGetMessageCount(java.lang.String sFolderID,
                                     int iDepth,
                                     PropertyValue[] filterProps,
                                     boolean bOr,
                                     boolean bNot,
                                     boolean bHidden)
                              throws ExchangeException

  Queries the server to get a count of messages.

  Parameters:
    `sFolderID` - the folder ID
    `iDepth` - the depth of folders to use when calculating message count (0 for only starting folder, N for depth of N, -1 for infinite depth)
    `filterProps` - the properties to filter by; passing `null` in this parameter will not traverse subfolders, even if -1 is specified for `iDepth`
    `bOr` - if `true`, or the filter properties together
    `bNot` - if `true`, the condition is opposite
    `bHidden` - if `true`, get hidden messages rather than visible ones
  Returns:
    the number of messages
  Throws:
    `ExchangeException`

### serverGetMessageCount

    public int serverGetMessageCount(DefaultFolderType type,
                                     int iDepth,
                                     PropertyValue[] filterProps,
                                     boolean bOr,
                                     boolean bNot,
                                     boolean bHidden)
                              throws ExchangeException

  Queries the server to get a count of messages.

  Parameters:
    `type` - the default folder type
    `iDepth` - the depth of folders to use when calculating message count (0 for only starting folder, N for depth of N, -1 for infinite depth)
    `filterProps` - the properties to filter by
    `bOr` - if `true`, or the filter properties together
    `bNot` - if `true`, the condition is opposite
    `bHidden` - if `true`, get hidden messages rather than visible ones
  Returns:
    the number of messages
  Throws:
    `ExchangeException`

### serverCreateMessage

    public java.lang.String serverCreateMessage(java.lang.String sFolderID,
                                                PropertyValue[] values)
                                         throws ExchangeException

  Hits the server to create a message.

  Parameters:
    `sFolderID` - the ID of the folder that the message will go in
    `values` - any initial property values to set
  Returns:
    the new message ID
  Throws:
    `ExchangeException` - if a problem occurs while connecting to or interacting with Exchange

### serverCreateMessage

    public java.lang.String serverCreateMessage(java.lang.String sFolderID,
                                                PropertyValue[] values,
                                                Recipient[] recipients)
                                         throws ExchangeException

  Hits the server to create a message.

  Parameters:
    `sFolderID` - the ID of the folder that the message will go in
    `values` - any initial property values to set
    `recipients` - the initial recipients to add to the message (`null` for no initial recipients)
  Returns:
    the new message ID
  Throws:
    `ExchangeException` - if a problem occurs while connecting to or interacting with Exchange

### serverCreateContact

    public Contact serverCreateContact(DefaultFolderType type,
                                       PropertyValue[] values)
                                throws ExchangeException

  Hits the server to create a contact.

  Parameters:
    `type` - the default folder type
    `values` - any initial property values to set
  Returns:
    the newly created contact
  Throws:
    `ExchangeException`

### serverCreateContact

    public Contact serverCreateContact(java.lang.String sFolderID,
                                       PropertyValue[] values)
                                throws ExchangeException

  Hits the server to create a contact.

  Parameters:
    `sFolderID` - the ID of the folder that the message will go in
    `values` - any initial property values to set
  Returns:
    the newly created contact
  Throws:
    `ExchangeException`

### serverUpdateTaskFromRequest

    public boolean serverUpdateTaskFromRequest(DefaultFolderType folderType,
                                               java.lang.String sTaskRequestID)
                                        throws ExchangeException

  Updates a linked task from a task request.

  Parameters:
    `sTaskRequestID` - the ID of the task request
  Returns:
    the newly created task
  Throws:
    `ExchangeException`

### serverUpdateTaskFromRequest

    public boolean serverUpdateTaskFromRequest(java.lang.String sFolderID,
                                               java.lang.String sTaskRequestID)
                                        throws ExchangeException

  Updates a linked task from a task request.

  Parameters:
    `sFolderID` - the ID of the folder that the task request is in (may be `null`)
    `sTaskRequestID` - the ID of the task request
  Returns:
    the newly created task
  Throws:
    `ExchangeException`

### serverCreateTask

    public Task serverCreateTask(DefaultFolderType type,
                                 PropertyValue[] values)
                          throws ExchangeException

  Hits the server to create a task.

  Parameters:
    `type` - the default folder type
    `values` - any initial property values to set
  Returns:
    the newly created task
  Throws:
    `ExchangeException`

### serverCreateTaskRequest

    public Message serverCreateTaskRequest(DefaultFolderType type,
                                           java.lang.String sTaskID,
                                           PropertyValue[] values,
                                           Recipient[] recipients,
                                           boolean bSend,
                                           boolean bSaveInSent)
                                    throws ExchangeException

  Hits the server to create a task.

  Parameters:
    `type` - the default folder type
    `sTaskID` - the ID of the task to create a request from
    `values` - any initial property values to set
    `bSend` - if `true`, send the task request
    `bSaveInSent` - if `true` and sending the request, save the task request in the sent items folder
  Returns:
    the newly created task request message, or `null` if the message is being sent
  Throws:
    `ExchangeException`

### serverCreateTask

    public Task serverCreateTask(java.lang.String sFolderID,
                                 PropertyValue[] values)
                          throws ExchangeException

  Hits the server to create a task.

  Parameters:
    `sFolderID` - the ID of the folder that the message will go in
    `values` - any initial property values to set
  Returns:
    the newly created task
  Throws:
    `ExchangeException`

### serverCreateTaskRequest

    public Message serverCreateTaskRequest(java.lang.String sFolderID,
                                           java.lang.String sTaskID,
                                           PropertyValue[] values,
                                           Recipient[] recipients,
                                           boolean bSend,
                                           boolean bSaveInSent)
                                    throws ExchangeException

  Hits the server to create a task request.

  Parameters:
    `sFolderID` - the ID of the folder that the message will go in
    `sTaskID` - the ID of the task to create a request from
    `values` - any initial property values to set
    `bSend` - if `true`, send the task request
    `bSaveInSent` - if `true` and sending the request, save the task request in the sent items folder
  Returns:
    the newly created task request message, or `null` if the message is being sent
  Throws:
    `ExchangeException`

### serverCreateJournal

    public Journal serverCreateJournal(java.lang.String sFolderID,
                                       PropertyValue[] values)
                                throws ExchangeException

  Hits the server to create a journal entry.

  Parameters:
    `sFolderID` - the ID of the folder that the message will go in
    `values` - any initial property values to set
  Returns:
    the newly created journal entry
  Throws:
    `ExchangeException`

### serverCreateJournal

    public Journal serverCreateJournal(DefaultFolderType type,
                                       PropertyValue[] values)
                                throws ExchangeException

  Hits the server to create a journal entry.

  Parameters:
    `type` - the default folder type
    `values` - any initial property values to set
  Returns:
    the newly created journal entry
  Throws:
    `ExchangeException`

### serverCreateAppointment

    public Appointment serverCreateAppointment(java.lang.String sFolderID,
                                               PropertyValue[] values,
                                               Recipient[] recipients,
                                               RecurrencePattern pattern)
                                        throws ExchangeException

  Hits the server to create an appointment.

  Parameters:
    `sFolderID` - the ID of the folder that the appointment will go in
    `values` - any initial property values to set
    `recipients` - initial recipients to add
    `pattern` - the recurrence pattern for the appointment (or `null` to create a non-recurring appointment)
  Returns:
    the newly created appointment
  Throws:
    `ExchangeException`

### serverCreateAppointment

    public Appointment serverCreateAppointment(java.lang.String sFolderID,
                                               PropertyValue[] values,
                                               Recipient[] recipients,
                                               RecurrencePattern pattern,
                                               boolean bSend,
                                               boolean bSaveSent)
                                        throws ExchangeException

  Hits the server to create an appointment.

  Parameters:
    `sFolderID` - the ID of the folder that the appointment will go in
    `values` - any initial property values to set
    `recipients` - initial recipients to add
    `pattern` - the recurrence pattern for the appointment (or `null` to create a non-recurring appointment)
    `bSend` - if `true`, send the appointment after it is created (for meeting requests)
    `bSaveSent` - if `true`, save the sent message in the sent items folder
  Returns:
    the newly created appointment
  Throws:
    `ExchangeException`

### serverCreateAppointment

    public Appointment serverCreateAppointment(DefaultFolderType type,
                                               PropertyValue[] values,
                                               Recipient[] recipients,
                                               RecurrencePattern pattern)
                                        throws ExchangeException

  Hits the server to create an appointment.

  Parameters:
    `type` - the default folder type
    `values` - any initial property values to set
    `recipients` - initial recipients to add
    `pattern` - the recurrence pattern for the appointment (or `null` to create a non-recurring appointment)
  Returns:
    the newly created appointment
  Throws:
    `ExchangeException`

### serverCreateAppointment

    public Appointment serverCreateAppointment(DefaultFolderType type,
                                               PropertyValue[] values,
                                               Recipient[] recipients,
                                               RecurrencePattern pattern,
                                               boolean bSend,
                                               boolean bSaveSent)
                                        throws ExchangeException

  Hits the server to create an appointment.

  Parameters:
    `type` - the default folder type
    `values` - any initial property values to set
    `recipients` - initial recipients to add
    `pattern` - the recurrence pattern for the appointment (or `null` to create a non-recurring appointment)
    `bSend` - if `true`, send the appointment after it is created (for meeting requests)
    `bSaveSent` - if `true`, save the sent message in the sent items folder
  Returns:
    the newly created appointment
  Throws:
    `ExchangeException`

### serverCreateMessage

    public java.lang.String serverCreateMessage(DefaultFolderType folderType,
                                                PropertyValue[] values)
                                         throws ExchangeException

  Hits the server to create a message.

  Parameters:
    `folderType` - the default folder type the message will go in
    `values` - any initial property values to set
  Returns:
    the new message with properties loaded for each of the `keys`
  Throws:
    `ExchangeException` - if a problem occurs while connecting to or interacting with Exchange

### serverCreateMessage

    public java.lang.String serverCreateMessage(DefaultFolderType folderType,
                                                PropertyValue[] values,
                                                Recipient[] recipients)
                                         throws ExchangeException

  Hits the server to create a message.

  Parameters:
    `folderType` - the default folder type the message will go in
    `values` - any initial property values to set
    `recipients` - the initial recipients to add to the message (`null` for no initial recipients)
  Returns:
    the new message with properties loaded for each of the `keys`
  Throws:
    `ExchangeException` - if a problem occurs while connecting to or interacting with Exchange

### serverUpdateMessage

    public void serverUpdateMessage(java.lang.String sMessageID,
                                    PropertyValue[] values)
                             throws ExchangeException

  Hits the server to update a message.

  Parameters:
    `sMessageID` - the ID of the message to update
    `values` - the property values to set
  Throws:
    `ExchangeException`

### serverUpdateMessages

    public void serverUpdateMessages(java.lang.String[] messageIDs,
                                     PropertyValue[] values)
                              throws ExchangeException

  Hits the server to update the specified messages.

  Parameters:
    `messageIDs` - the IDs of the messages to update
    `values` - the property values to set
  Throws:
    `ExchangeException`

### serverUpdateMessages

    public void serverUpdateMessages(java.lang.String[] messageIDs,
                                     PropertyValue[] values,
                                     Recipient[] recipients,
                                     boolean bSend,
                                     boolean bSaveInSent)
                              throws ExchangeException

  Hits the server to update the specified messages.

  Parameters:
    `messageIDs` - the IDs of the messages to update
    `values` - the property values to set (or `null` for no properties to update)
    `recipients` - the recipients to add to the message (or `null` for no recipients to add)
    `bSend` - if `true`, send the message
    `bSaveInSent` - if `true` and sending the message, save the message in the `Sent Items` folder
  Throws:
    `ExchangeException`

### serverUpdateMessages

    public void serverUpdateMessages(java.lang.String[] messageIDs,
                                     PropertyValue[] values,
                                     Recipient[] recipients,
                                     ResponseStatus responseStatus,
                                     boolean bSend,
                                     boolean bSaveInSent)
                              throws ExchangeException

  Hits the server to update the specified messages.

  Parameters:
    `messageIDs` - the IDs of the messages to update
    `values` - the property values to set (or `null` for no properties to update)
    `recipients` - the recipients to add to the message (or `null` for no recipients to add)
    `bSend` - if `true`, send the message
    `bSaveInSent` - if `true` and sending the message, save the message in the `Sent Items` folder
  Throws:
    `ExchangeException`

### serverUpdateMessages

    public void serverUpdateMessages(java.lang.String[] messageIDs,
                                     PropertyValue[] values,
                                     Recipient[] recipients,
                                     ResponseStatus responseStatus,
                                     boolean bSeries,
                                     boolean bSend,
                                     boolean bSaveInSent)
                              throws ExchangeException

  Hits the server to update the specified messages.

  Parameters:
    `messageIDs` - the IDs of the messages to update
    `values` - the property values to set (or `null` for no properties to update)
    `recipients` - the recipients to add to the message (or `null` for no recipients to add)
    `bSeries` - if `true` and the message is a recurring appointment, edit the series
    `bSend` - if `true`, send the message
    `bSaveInSent` - if `true` and sending the message, save the message in the `Sent Items` folder
  Throws:
    `ExchangeException`

### serverUpdateMessages

    public void serverUpdateMessages(java.lang.String[] messageIDs,
                                     java.lang.String sFolderID,
                                     PropertyValue[] values,
                                     Recipient[] recipients,
                                     ResponseStatus responseStatus,
                                     boolean bSeries,
                                     boolean bSend,
                                     boolean bSaveInSent)
                              throws ExchangeException

  Hits the server to update the specified messages.

  Parameters:
    `messageIDs` - the IDs of the messages to update
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `values` - the property values to set (or `null` for no properties to update)
    `recipients` - the recipients to add to the message (or `null` for no recipients to add)
    `bSeries` - if `true` and the message is a recurring appointment, edit the series
    `bSend` - if `true`, send the message
    `bSaveInSent` - if `true` and sending the message, save the message in the `Sent Items` folder
  Throws:
    `ExchangeException`

### serverUpdateMessages

    public void serverUpdateMessages(java.lang.String[] messageIDs,
                                     PropertyValue[] values,
                                     Recipient[] recipients,
                                     RecurrencePattern pattern,
                                     ResponseStatus responseStatus,
                                     boolean bSeries,
                                     boolean bSend,
                                     boolean bSaveInSent)
                              throws ExchangeException

  Hits the server to update the specified messages.

  Parameters:
    `messageIDs` - the IDs of the messages to update
    `values` - the property values to set (or `null` for no properties to update)
    `recipients` - the recipients to add to the message (or `null` for no recipients to add)
    `pattern` - if the message is an appointment, update the recurrence pattern with the specified pattern
    `bSeries` - if `true` and the message is a recurring appointment, edit the series
    `bSend` - if `true`, send the message
    `bSaveInSent` - if `true` and sending the message, save the message in the `Sent Items` folder
  Throws:
    `ExchangeException`

### serverUpdateMessages

    public void serverUpdateMessages(java.lang.String[] messageIDs,
                                     java.lang.String sFolderID,
                                     PropertyValue[] values,
                                     Recipient[] recipients,
                                     RecurrencePattern pattern,
                                     ResponseStatus responseStatus,
                                     boolean bSeries,
                                     boolean bSend,
                                     boolean bSaveInSent)
                              throws ExchangeException

  Hits the server to update the specified messages.

  Parameters:
    `messageIDs` - the IDs of the messages to update
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `values` - the property values to set (or `null` for no properties to update)
    `recipients` - the recipients to add to the message (or `null` for no recipients to add)
    `pattern` - if the message is an appointment, update the recurrence pattern with the specified pattern
    `responseStatus` - the meeting response status (this parameter and the taskResponseStatus parameter are mutually exclusive)
    `bSeries` - if `true` and the message is a recurring appointment, edit the series
    `bSend` - if `true`, send the message
    `bSaveInSent` - if `true` and sending the message, save the message in the `Sent Items` folder
  Throws:
    `ExchangeException`

### serverUpdateMessages

    public void serverUpdateMessages(java.lang.String[] messageIDs,
                                     java.lang.String sFolderID,
                                     PropertyValue[] values,
                                     Recipient[] recipients,
                                     RecurrencePattern pattern,
                                     ResponseStatus responseStatus,
                                     TaskResponseStatus taskResponseStatus,
                                     boolean bSeries,
                                     boolean bSend,
                                     boolean bSaveInSent)
                              throws ExchangeException

  Hits the server to update the specified messages.

  Parameters:
    `messageIDs` - the IDs of the messages to update
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `values` - the property values to set (or `null` for no properties to update)
    `recipients` - the recipients to add to the message (or `null` for no recipients to add)
    `pattern` - if the message is an appointment, update the recurrence pattern with the specified pattern
    `responseStatus` - the meeting response status (this parameter and the taskResponseStatus parameter are mutually exclusive)
    `taskResponseStatus` - the task response status (this parameter and the responseStatus parameter are mutually exclusive)
    `bSeries` - if `true` and the message is a recurring appointment, edit the series
    `bSend` - if `true`, send the message
    `bSaveInSent` - if `true` and sending the message, save the message in the `Sent Items` folder
  Throws:
    `ExchangeException`

### serverUpdateMessages

    public void serverUpdateMessages(java.lang.String[] messageIDs,
                                     java.lang.String sFolderID,
                                     PropertyValue[] values,
                                     Recipient[] recipients,
                                     int[] deleteRecipients,
                                     RecurrencePattern pattern,
                                     ResponseStatus responseStatus,
                                     boolean bSeries,
                                     boolean bSend,
                                     boolean bSaveInSent)
                              throws ExchangeException

  Hits the server to update the specified messages.

  Parameters:
    `messageIDs` - the IDs of the messages to update
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `values` - the property values to set (or `null` for no properties to update)
    `recipients` - the recipients to add to the message (or `null` for no recipients to add)
    `deleteRecipients` - the recipients to delete from the message (or `null` for no recipients to delete)
    `pattern` - if the message is an appointment, update the recurrence pattern with the specified pattern
    `bSeries` - if `true` and the message is a recurring appointment, edit the series
    `bSend` - if `true`, send the message
    `bSaveInSent` - if `true` and sending the message, save the message in the `Sent Items` folder
  Throws:
    `ExchangeException`

### serverUpdateMessages

    public void serverUpdateMessages(java.lang.String[] messageIDs,
                                     java.lang.String sFolderID,
                                     PropertyValue[] values,
                                     Recipient[] recipients,
                                     int[] deleteRecipients,
                                     RecurrencePattern pattern,
                                     ResponseStatus responseStatus,
                                     TaskResponseStatus taskResponseStatus,
                                     TaskStatus taskStatus,
                                     boolean bSeries,
                                     boolean bSend,
                                     boolean bSaveInSent)
                              throws ExchangeException

  Hits the server to update the specified messages.

  Parameters:
    `messageIDs` - the IDs of the messages to update
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `values` - the property values to set (or `null` for no properties to update)
    `recipients` - the recipients to add to the message (or `null` for no recipients to add)
    `deleteRecipients` - the recipients to delete from the message (or `null` for no recipients to delete)
    `pattern` - if the message is an appointment, update the recurrence pattern with the specified pattern
    `responseStatus` - the meeting response status (this parameter, the taskResponseStatus parameter and the taskStatus parameter are mutually exclusive)
    `taskResponseStatus` - the task response status (this parameter, the responseStatus parameter and the `taskStatus` parameter are mutually exclusive)
    `taskStatus` - the task response status (this parameter, the responseStatus parameter and the taskResponseStatus are mutually exclusive)
    `bSeries` - if `true` and the message is a recurring appointment, edit the series
    `bSend` - if `true`, send the message
    `bSaveInSent` - if `true` and sending the message, save the message in the `Sent Items` folder
  Throws:
    `ExchangeException`

### serverForwardMessage

    public Message serverForwardMessage(java.lang.String sMessageID,
                                        PropertyValue[] values,
                                        PropertyKey[] keys)
                                 throws ExchangeException

  Hits the server to create a new message in the oubox suitable for forwarding a specified message. All properties and attachments of the original message are copied to the forwarded message. The message subject remains unmodified.

  Parameters:
    `sMessageID` - the ID of the message to forward
    `values` - the property values to set
    `keys` - the keys for the properties to receive on the new message
  Returns:
    the new message suitable for forwarding
  Throws:
    `ExchangeException`

### serverForwardMessage

    public Message serverForwardMessage(java.lang.String sMessageID,
                                        PropertyValue[] values,
                                        PropertyKey[] keys,
                                        boolean bCopyRichText)
                                 throws ExchangeException

  Hits the server to create a new message in the oubox suitable for forwarding a specified message. All properties and attachments of the original message are copied to the forwarded message. The message subject remains unmodified.

  Parameters:
    `sMessageID` - the ID of the message to forward
    `values` - the property values to set
    `keys` - the keys for the properties to receive on the new message
    `bCopyRichText` - if `true`, copy the rich text from the original message to the forwarded message (it is then up to the client to add annotation to the rich text and to set the `MESSAGE_RTF` on the forwarded message, otherwise if a user changes the text property this will not be reflected in the RTF of the forwarded message)
  Returns:
    the new message suitable for forwarding
  Throws:
    `ExchangeException`

### serverForwardMessage

    public Message serverForwardMessage(java.lang.String sMessageID,
                                        java.lang.String sFolderID,
                                        PropertyValue[] values,
                                        PropertyKey[] keys)
                                 throws ExchangeException

  Hits the server to create a new message in the oubox suitable for forwarding a specified message. All properties and attachments of the original message are copied to the forwarded message. The message subject remains unmodified.

  Parameters:
    `sMessageID` - the ID of the message to forward
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `values` - the property values to set
    `keys` - the keys for the properties to receive on the new message
  Returns:
    the new message suitable for forwarding
  Throws:
    `ExchangeException`

### serverForwardMessage

    public Message serverForwardMessage(java.lang.String sMessageID,
                                        java.lang.String sFolderID,
                                        PropertyValue[] values,
                                        PropertyKey[] keys,
                                        boolean bCopyRichText)
                                 throws ExchangeException

  Hits the server to create a new message in the oubox suitable for forwarding a specified message. All properties and attachments of the original message are copied to the forwarded message. The message subject remains unmodified.

  Parameters:
    `sMessageID` - the ID of the message to forward
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `values` - the property values to set
    `keys` - the keys for the properties to receive on the new message
    `bCopyRichText` - if `true`, copy the rich text from the original message to the forwarded message (it is then up to the client to add annotation to the rich text and to set the `MESSAGE_RTF` on the forwarded message, otherwise if a user changes the text property this will not be reflected in the RTF of the forwarded message)
  Returns:
    the new message suitable for forwarding
  Throws:
    `ExchangeException`

### serverForwardMessage

    public Message serverForwardMessage(java.lang.String sMessageID,
                                        java.lang.String sFolderID,
                                        PropertyValue[] values,
                                        PropertyKey[] keys,
                                        boolean bCopyRichText,
                                        boolean bSeries)
                                 throws ExchangeException

  Hits the server to create a new message in the oubox suitable for forwarding a specified message. All properties and attachments of the original message are copied to the forwarded message. The message subject remains unmodified.

  Parameters:
    `sMessageID` - the ID of the message to forward
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `values` - the property values to set
    `keys` - the keys for the properties to receive on the new message
    `bCopyRichText` - if `true`, copy the rich text from the original message to the forwarded message (it is then up to the client to add annotation to the rich text and to set the `MESSAGE_RTF` on the forwarded message, otherwise if a user changes the text property this will not be reflected in the RTF of the forwarded message)
    `bSeries` - forwards the message series (for appointments)
  Returns:
    the new message suitable for forwarding
  Throws:
    `ExchangeException`

### serverReplyToMessage

    public Message serverReplyToMessage(java.lang.String sMessageID,
                                        PropertyValue[] values,
                                        PropertyKey[] keys,
                                        boolean bReplyAll)
                                 throws ExchangeException

  Hits the server to create a new message in the outbox suitable for replying to a specified message. The `TO` field of the message is set from the original sender of the message. In keeping with reply conventions, the attachments on the original message are not copied into the reply. The message subject remains unmodified.

  Parameters:
    `sMessageID` - the ID of the message to reply to
    `values` - the property values on the new message to set
    `keys` - the keys for the properties to receive on the new message
    `bReplyAll` - if `true`, reply to all original recipients of the message
  Returns:
    the new message suitable for replying
  Throws:
    `ExchangeException`

### serverReplyToMessage

    public Message serverReplyToMessage(java.lang.String sMessageID,
                                        java.lang.String sFolderID,
                                        PropertyValue[] values,
                                        PropertyKey[] keys,
                                        boolean bReplyAll)
                                 throws ExchangeException

  Hits the server to create a new message in the outbox suitable for replying to a specified message. The `TO` field of the message is set from the original sender of the message. In keeping with reply conventions, the attachments on the original message are not copied into the reply. The message subject remains unmodified.

  Parameters:
    `sMessageID` - the ID of the message to reply to
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `values` - the property values on the new message to set
    `keys` - the keys for the properties to receive on the new message
    `bReplyAll` - if `true`, reply to all original recipients of the message
  Returns:
    the new message suitable for replying
  Throws:
    `ExchangeException`

### serverRespondToMeetingRequest

    public void serverRespondToMeetingRequest(java.lang.String sMessageID,
                                              PropertyValue[] values,
                                              ResponseStatus status)
                                       throws ExchangeException

  Hits the server to reply immediately to a meeting request. The `TO` field of the message is set from the original sender of the request.

  Parameters:
    `sMessageID` - the ID of the message to reply to
    `values` - the property values on the new message to set
    `status` - the meeting response status
  Returns:
    the new message suitable for replying
  Throws:
    `ExchangeException`

### serverRespondToMeetingRequest

    public void serverRespondToMeetingRequest(java.lang.String sMessageID,
                                              java.lang.String sFolderID,
                                              PropertyValue[] values,
                                              ResponseStatus status)
                                       throws ExchangeException

  Hits the server to reply immediately to a meeting request. The `TO` field of the message is set from the original sender of the request.

  Parameters:
    `sMessageID` - the ID of the message to reply to
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `values` - the property values on the new message to set
    `status` - the meeting response status
  Returns:
    the new message suitable for replying
  Throws:
    `ExchangeException`

### serverRespondToTaskRequest

    public void serverRespondToTaskRequest(java.lang.String sMessageID,
                                           PropertyValue[] values,
                                           TaskResponseStatus status)
                                    throws ExchangeException

  Hits the server to respond to to a task request. The `TO` field of the message is set from the original sender of the request. The task request is saved in the sent items folder.

  Parameters:
    `sMessageID` - the ID of the message to reply to
    `values` - the property values on the new message to set
    `status` - the response status
  Throws:
    `ExchangeException`

### serverRespondToTaskRequest

    public void serverRespondToTaskRequest(java.lang.String sMessageID,
                                           java.lang.String sFolderID,
                                           PropertyValue[] values,
                                           TaskResponseStatus status,
                                           boolean bSaveSent)
                                    throws ExchangeException

  Hits the server to respond to a task request. The `TO` field of the message is set from the original sender of the request.

  Parameters:
    `sMessageID` - the ID of the message to reply to
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `values` - the property values on the new message to set
    `status` - the task response status
    `bSaveSent` - if `true`, save in sent folder
  Throws:
    `ExchangeException`

### serverUpdateTaskRequest

    public void serverUpdateTaskRequest(java.lang.String sMessageID,
                                        PropertyValue[] values,
                                        TaskStatus taskStatus,
                                        boolean bSaveInSent)
                                 throws ExchangeException

  Hits the server to update the specified task and send an update to the originator of the task request that created it.

  Parameters:
    `values` - the property values to set on the task (or `null` for no properties to update)
    `taskStatus` - the new task status
    `bSaveInSent` - if `true` and sending the message, save the message in the `Sent Items` folder
  Throws:
    `ExchangeException`

### serverCancelMeeting

    protected void serverCancelMeeting(java.lang.String sMessageID,
                                       PropertyValue[] values,
                                       boolean bSeries,
                                       boolean bSend,
                                       boolean bSaveInSent,
                                       boolean bDelete)
                                throws ExchangeException

  Hits the server to delete a send a meeting cancellation and optionally delete the meeting.

  Parameters:
    `sMessageID` - the ID of the message
    `bSeries` - if `true`, cancel the entire series
    `bSend` - if `true`, send the cancellation
    `bSaveInSent` - if `true` and sending the cancellation, save it in the sent folder
    `bDelete` - if `true`, delete the appointment
  Throws:
    `ExchangeException`

### serverDeleteMessages

    public void serverDeleteMessages(java.lang.String[] messageIDs,
                                     boolean bDeletedItems)
                              throws ExchangeException

  Hits the server to delete the specified messages.

  Parameters:
    `messageIDs` - the IDs of the messages to delete
    `bDeletedItems` - if `true`, place message into deleted items
  Throws:
    `ExchangeException`

### serverDeleteMessages

    public void serverDeleteMessages(java.lang.String[] messageIDs,
                                     java.lang.String sFolderID,
                                     boolean bDeletedItems)
                              throws ExchangeException

  Hits the server to delete the specified messages.

  Parameters:
    `messageIDs` - the IDs of the messages to delete
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `bDeletedItems` - if `true`, place message into deleted items
  Throws:
    `ExchangeException`

### serverDeleteMessages

    public void serverDeleteMessages(java.lang.String[] messageIDs,
                                     boolean bDeletedItems,
                                     boolean bDeleteSeries)
                              throws ExchangeException

  Hits the server to delete the specified messages.

  Parameters:
    `messageIDs` - the IDs of the messages to delete
    `bDeletedItems` - if `true`, place message into deleted items
    `bDeleteSeries` - if `true` and the message is a recurring appointment, delete all instances of the recurring appointment rather than just the specified instance
  Throws:
    `ExchangeException`

### serverDeleteMessages

    public void serverDeleteMessages(java.lang.String[] messageIDs,
                                     java.lang.String sFolderID,
                                     boolean bDeletedItems,
                                     boolean bDeleteSeries)
                              throws ExchangeException

  Hits the server to delete the specified messages.

  Parameters:
    `messageIDs` - the IDs of the messages to delete
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `bDeletedItems` - if `true`, place message into deleted items
    `bDeleteSeries` - if `true` and the message is a recurring appointment, delete all instances of the recurring appointment rather than just the specified instance
  Throws:
    `ExchangeException`

### serverCopyMessages

    public void serverCopyMessages(java.lang.String[] srcMessageIDs,
                                   java.lang.String sTargetFolderID)
                            throws ExchangeException

  Hits the server to copy the specified messages to another folder.

  Parameters:
    `srcMessageIDs` - the ID of the source messages
    `sTargetFolderID` - the ID of the target folder
  Throws:
    `ExchangeException`

### serverCopyMessages

    public void serverCopyMessages(java.lang.String[] srcMessageIDs,
                                   java.lang.String sFolderID,
                                   java.lang.String sTargetFolderID)
                            throws ExchangeException

  Hits the server to copy the specified messages to another folder.

  Parameters:
    `srcMessageIDs` - the ID of the source messages
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `sTargetFolderID` - the ID of the target folder
  Throws:
    `ExchangeException`

### serverMoveMessages

    public void serverMoveMessages(java.lang.String[] srcMessageIDs,
                                   DefaultFolderType folderType)
                            throws ExchangeException

  Hits the server to move the specified messages to another folder.

  Parameters:
    `srcMessageIDs` - the ID of the source messages
    `folderType` - the default folder type the message will go in
  Throws:
    `ExchangeException`

### serverMoveMessages

    public void serverMoveMessages(java.lang.String[] srcMessageIDs,
                                   java.lang.String sFolderID,
                                   DefaultFolderType folderType)
                            throws ExchangeException

  Hits the server to move the specified messages to another folder.

  Parameters:
    `srcMessageIDs` - the ID of the source messages
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `folderType` - the default folder type the message will go in
  Throws:
    `ExchangeException`

### serverMoveMessages

    public void serverMoveMessages(java.lang.String[] srcMessageIDs,
                                   java.lang.String sTargetFolderID)
                            throws ExchangeException

  Hits the server to move the specified messages to another folder.

  Parameters:
    `srcMessageIDs` - the ID of the source messages
    `sTargetFolderID` - the ID of the target folder
  Throws:
    `ExchangeException`

### serverMoveMessages

    public void serverMoveMessages(java.lang.String[] srcMessageIDs,
                                   java.lang.String sFolderID,
                                   java.lang.String sTargetFolderID)
                            throws ExchangeException

  Hits the server to move the specified messages to another folder.

  Parameters:
    `srcMessageIDs` - the ID of the source messages
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `sTargetFolderID` - the ID of the target folder
  Throws:
    `ExchangeException`

### serverAddAttachment

    public int serverAddAttachment(java.lang.String sMessageID,
                                   AttachmentType attachmentType,
                                   java.lang.String sName,
                                   java.lang.String sSource,
                                   int iPosition,
                                   javax.activation.DataHandler handler)
                            throws ExchangeException

  Hits the server to add an attachment to a message. The source that should be specified depends on the attachment type as follows:
  - `AttachmentType.FILE_DATA` - source parameter is ignored, pass in `null`
  - `AttachmentType.FILE_LINK` - pass in a link in UNC form, such as `\\server\path\file.doc`
  - `AttachmentType.OLE` - source parameter is ignored, pass in `null`
  - `AttachmentType.EMBEDDED_MESSAGE` - source parameter should be an ID to a message

  Parameters:
    `sMessageID` - the message ID
    `attachmentType` - the attachment type
    `sName` - the display name of the attachment
    `sSource` - the attachment source
    `iPosition` - the position of the attachment in the message
    `handler` - a handler that can supply the attachment data
  Returns:
    the index of the newly added attachment in the attachments collection of the message
  Throws:
    `ExchangeException`

### serverAddAttachment

    public int serverAddAttachment(java.lang.String sMessageID,
                                   java.lang.String sFolderID,
                                   AttachmentType attachmentType,
                                   java.lang.String sName,
                                   java.lang.String sSource,
                                   int iPosition,
                                   javax.activation.DataHandler handler)
                            throws ExchangeException

  Hits the server to add an attachment to a message. The source that should be specified depends on the attachment type as follows:
  - `AttachmentType.FILE_DATA` - source parameter is ignored, pass in `null`
  - `AttachmentType.FILE_LINK` - pass in a link in UNC form, such as `\\server\path\file.doc`
  - `AttachmentType.OLE` - source parameter is ignored, pass in `null`
  - `AttachmentType.EMBEDDED_MESSAGE` - source parameter should be an ID to a message

  Parameters:
    `sMessageID` - the message ID
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `attachmentType` - the attachment type
    `sName` - the display name of the attachment
    `sSource` - the attachment source
    `iPosition` - the position of the attachment in the message
    `handler` - a handler that can supply the attachment data
  Returns:
    the index of the newly added attachment in the attachments collection of the message
  Throws:
    `ExchangeException`

### serverDeleteAttachment

    public void serverDeleteAttachment(java.lang.String sMessageID,
                                       int iIndex)
                                throws ExchangeException

  Hits the server to delete an attachment from a message.

  Parameters:
    `sMessageID` - the message ID
    `iIndex` - the index of the attachment in the attachments collection of the message
  Throws:
    `ExchangeException`

### serverDeleteAttachment

    public void serverDeleteAttachment(java.lang.String sMessageID,
                                       java.lang.String sFolderID,
                                       int iIndex)
                                throws ExchangeException

  Hits the server to delete an attachment from a message.

  Parameters:
    `sMessageID` - the message ID
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `iIndex` - the index of the attachment in the attachments collection of the message
  Throws:
    `ExchangeException`

### serverGetAttachments

    public Attachment[] serverGetAttachments(java.lang.String sMessageID,
                                             PropertyKey[] keys)
                                      throws ExchangeException

  Hits the server to get detailed information about an attachment.

  Parameters:
    `sMessageID` - the message id
    `keys` - the properties to fetch for each attachment
  Throws:
    `ExchangeException`

### serverGetAttachments

    public Attachment[] serverGetAttachments(java.lang.String sMessageID,
                                             java.lang.String sFolderID,
                                             PropertyKey[] keys)
                                      throws ExchangeException

  Hits the server to get detailed information about an attachment.

  Parameters:
    `sMessageID` - the message id
    `sFolderID` - the folder id that contains the message
    `keys` - the properties to fetch for each attachment
  Throws:
    `ExchangeException`

### serverGetAttachment

    public javax.activation.DataHandler serverGetAttachment(java.lang.String sMessageID,
                                                            int iIndex)
                                                     throws ExchangeException

  Hits the server to get an attachment from a message.

  Parameters:
    `sMessageID` - the message ID
    `iIndex` - the index of the attachment in the attachments collection of the message
  Returns:
    a handler that can supply the attachment data
  Throws:
    `ExchangeException`

### serverGetAttachment

    public javax.activation.DataHandler serverGetAttachment(java.lang.String sMessageID,
                                                            java.lang.String sFolderID,
                                                            int iIndex)
                                                     throws ExchangeException

  Hits the server to get an attachment from a message.

  Parameters:
    `sMessageID` - the message ID
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `iIndex` - the index of the attachment in the attachments collection of the message
  Returns:
    a handler that can supply the attachment data
  Throws:
    `ExchangeException`

### serverGetAttachment

    public javax.activation.DataHandler serverGetAttachment(java.lang.String sMessageID,
                                                            java.lang.String sFolderID,
                                                            int iEmbeddedIndex,
                                                            int iAttachmentIndex)
                                                     throws ExchangeException

  Hits the server to get an attachment from a message.

  Parameters:
    `sMessageID` - the message ID
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `iEmbeddedIndex` - the index of the embedded index, or -1 if the message is not embedded
    `iAttachmentIndex` - the index of the attachment in the attachments collection of the message
  Returns:
    a handler that can supply the attachment data
  Throws:
    `ExchangeException`

### serverGetEmbeddedMessage

    public Message serverGetEmbeddedMessage(java.lang.String sMessageID,
                                            java.lang.String sFolderID,
                                            PropertyKey[] messageKeys,
                                            int iIndex)
                                     throws ExchangeException

  Queries the server to get an embedded message (an attachment that is a message).

  Parameters:
    `sMessageID` - the message ID on which the embedded message is located
    `sFolderID` - the folder ID (used to get the message if it could not be retrieved off the session- may be `null`)
    `messageKeys` - the properties to fetch for the message
    `iIndex` - the index of the embedded message in the attachments collection
  Returns:
    the message, or null if it could not be found
  Throws:
    `ExchangeException`

### serverResolveRecipients

    public UnresolvedRecipient[] serverResolveRecipients(java.lang.String sMessageID,
                                                         boolean bRemove)
                                                  throws ExchangeException

  Resolves recipients on a message.

  Parameters:
    `sMessageID` - the message ID to resolve recipients
    `bRemove` - `true` to remove the unresolved recipients
  Returns:
    an array of unresolved recipients, or an array of zero length if none are found
  Throws:
    `ExchangeException` - if a problem occurs while connecting to or interacting with Exchange

### serverResolveRecipients

    public UnresolvedRecipient[] serverResolveRecipients(java.lang.String sMessageID,
                                                         boolean bRemove,
                                                         boolean bSeries)
                                                  throws ExchangeException

  Resolves recipients on a message.

  Parameters:
    `sMessageID` - the message ID to resolve recipients
    `bRemove` - `true` to remove the unresolved recipients
    `bSeries` - if `true` and the message is a recurring appointment, edit the series
  Returns:
    an array of unresolved recipients, or an array of zero length if none are found
  Throws:
    `ExchangeException` - if a problem occurs while connecting to or interacting with Exchange

### createDistLists

    public DistributionList[] createDistLists(Message[] messages)

  Creates an array of distribution lists from the messages.

  Parameters:
    `messages` - the array of messages to build the distribution lists (may not be `null`)

Overview | Package | Class | Tree | Deprecated | Index | Help
| Compoze Software, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright ©1999-2003 Compoze Software, Inc. All rights reserved.